/* --------------------------------------------------------
 Generated by Lukman Hakim using sql2java (http://sql2java.sourceforge.net/ )
 jdbc driver used at code generation time: net.sourceforge.jtds.jdbc.Driver
 
 Author : Lukman Hakim (lukman.uki@gmail.com) 
 Date Created : 26/10/2017
 --------------------------------------------------------
*/
package com.portofolio.dao;

import java.util.Map;

import org.springframework.cache.annotation.Cacheable;
import org.springframework.context.annotation.Lazy;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import org.springframework.data.jpa.repository.Query;
import org.springframework.data.repository.CrudRepository;
import org.springframework.data.repository.query.Param;
import org.springframework.stereotype.Repository;

import com.portofolio.entity.SettingDataFixed;
import com.portofolio.entity.vo.SettingDataFixedId;

@Lazy
@Repository
public interface SettingDataFixedMasterDao extends CrudRepository<SettingDataFixed, SettingDataFixedId> {

    @Query(QListAll)
    Page<Map<String, Object>> findAllList(@Param("kdProfile") Integer kdProfile, @Param("statusEnabled") boolean statusEnabled, Pageable page);
    
    
    @Query(QListAll + " and model.id.namaField like %:namaField% ")
    Page<Map<String, Object>> findAllList(@Param("kdProfile") Integer kdProfile, @Param("namaField") String namaField,@Param("statusEnabled") boolean statusEnabled, Pageable page);
    
    @Query(QListAll + " and model.id.namaField like :namaField ")
    Map<String, Object> findByNamaField(@Param("kdProfile") Integer kdProfile, @Param("namaField") String namaField,@Param("statusEnabled") boolean statusEnabled);
    
    String QListAll ="select new map(model.id as namaField "
            + ", model.typeField as typeField " 
            + ", model.nilaiField as nilaiField " 
            + ", model.tabelRelasi as tabelRelasi " 
            + ", model.fieldKeyTabelRelasi as fieldKeyTabelRelasi " 
            + ", model.fieldReportDisplayTabelRelasi as fieldReportDisplayTabelRelasi " 
            + ", model.keteranganFungsi as keteranganFungsi " 
            + ", model.statusEnabled as statusEnabled " 
            + ", model.noRec as noRec " 
            + ", model.version as version )" 
            + " from SettingDataFixed model "
            + "left join model.id id "
            + "where id.kdProfile=:kdProfile "
            + "and model.statusEnabled=:statusEnabled "; 
}
